﻿@page "/competitions/create/{CompetitionParentId:int}"
@page "/competitions/edit/{CompetitionId:int}/{CompetitionParentId:int}"

@using Models.CompetitionData
@using Business.Repository.IRepository
@inject NavigationManager NavigationManager
@inject IJSRuntime JsRuntime
@inject ICompetitionRepository CompetitionRepository
@inject ICompetitionParentRepository CompetitionParentRepository
@inject Blazored.LocalStorage.ILocalStorageService localStorage

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">@Title Competition</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@CompetitionModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@
                    <div class="form-group">
                        <label>League</label>
                        <InputText @bind-Value="CompetitionParentModel.Name" class="form-control" disabled="true"></InputText>
                    </div>
                    <div class="form-group">
                        <label>Name</label>
                        <InputText @bind-Value="CompetitionModel.Name" class="form-control"></InputText>
                        <ValidationMessage For="() => CompetitionModel.Name" />
                    </div>
                    <div class="form-group">
                        <button class="btn btn-primary">@Title competition</button>
                        <NavLink href="@($"competitions/{CompetitionParentId}")" class="btn btn-secondary">Back to Index</NavLink>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>



@code {

    [Parameter]
    public int? CompetitionId { get; set; }
    [Parameter]
    public int? CompetitionParentId { get; set; }
    private CompetitionDTO CompetitionModel { get; set; } = new CompetitionDTO();
    private CompetitionParentDTO CompetitionParentModel { get; set; } = new CompetitionParentDTO();
    private string currentSeason { get; set; }
    private string Title { get; set; } = "Create";
    protected override async Task OnInitializedAsync()
    {
        if (CompetitionId != null)
        {
            //update
            Title = "Update";
            CompetitionModel = await CompetitionRepository.Get(CompetitionId.Value);
            CompetitionParentModel = await CompetitionParentRepository.Get(CompetitionParentId.Value);
        }
        else
        {
            //create
            CompetitionParentModel = await CompetitionParentRepository.Get(CompetitionParentId.Value);
            CompetitionModel = new CompetitionDTO();
        }
        currentSeason = await localStorage.GetItemAsync<string>("seasonName");
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            // add check if competitionParent is unique
            // --
            // --
            if (CompetitionModel.Id != 0 && Title == "Update")
            {
                //update
                var updateCompetition = await CompetitionRepository.Update(CompetitionModel, CompetitionModel.Id);
                await JsRuntime.ToastrSuccess("Competition updated successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/competitions/" + CompetitionParentId, true);

            }
            else
            {
                //create
                CompetitionModel.CompetitionParentId = CompetitionParentId.Value;
                var createdResult = await CompetitionRepository.Create(CompetitionModel);

                await JsRuntime.ToastrSuccess("Competition created successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/competitions/" + CompetitionParentId, true);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
}
